
RevEng = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceHook-2.1", "AceDebug-2.0");

function RevEng:OnInitialize() 
	self.version = self.version..".".. string.sub("$Revision: 21252 $", 12, -3);
	self:SetDebugging(false);
end

function RevEng:OnEnable()
	self:RegisterEvent('TRADE_SKILL_SHOW', 'TradeSkillsOpened')
end

function RevEng:ScanFilter()
	for i=1, GetNumTradeSkills() do
		local itemlink = GetTradeSkillItemLink(i)
	end
end

function RevEng:TradeSkillsOpened()
	-- Now to scan and store skills by itemid
	self:RegisterEvent('TRADE_SKILL_CLOSE', 'TradeSkillsClosed')
	self.TradeSkills = {}
	SetTradeSkillSubClassFilter(0, 1, 1)
	for i=1, GetNumTradeSkills() do
		local itemName, itemType = GetTradeSkillInfo(i)
		if(itemType ~= "header") then
			local itemLink = GetTradeSkillItemLink(i)
			local _, _, link = string.find(itemLink or "", "-*:(%d+):.*")
			if (link) then
				self.TradeSkills[link] = {i, itemName}
			end
		else
			ExpandTradeSkillSubClass(i)
		end
	end
	self:Debug("Size of skills is: "..#self.TradeSkills);
	if(self.Hooks and self.Hooks[TradeSkillReagent1].OnClick and self.Hooks[TradeSkillReagent1].OnClick.active) then
	else
		for i=1,7 do
			local button = getglobal("TradeSkillReagent"..i); 
			self:HookScript(button, "OnClick", function() RevEng:Clicked(button, i) end)
			self:HookScript(button, "OnEnter", function() RevEng:Entered(button, i) end)
			self:HookScript(button, "OnLeave", function() RevEng:Left(button) end)
		end
	end
	if(not self.UpHistory) then
		self.UpHistory = CreateFrame("Button", "ReverseEngineeringUp", TradeSkillFrame)
		self.UpHistory:SetHeight(32)
		self.UpHistory:SetWidth(32)
		self.UpHistory:SetNormalTexture("Interface\\Buttons\\UI-RotationRight-Button-Up")
		self.UpHistory:SetPushedTexture("Interface\\Buttons\\UI-RotationRight-Button-Down")	
		self.UpHistory:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Round")
		self.UpHistory:SetScript("OnClick", function() RevEng:MoveUp() end)
		self.UpHistory:SetWidth(32)
		self.UpHistory:SetHeight(32)
	end
	self.UpHistory:ClearAllPoints()
	self.UpHistory:SetPoint("TOPRIGHT", TradeSkillDetailScrollFrameScrollBarScrollUpButton, "TOPLEFT")
	self.UpHistory:Show()

	if(not self.GearTexture) then
		self.GearTexture = TradeSkillFrame:CreateTexture(nil, "OVERLAY")
		self.GearTexture:SetTexture("Interface\\Icons\\Trade_Engineering")
		self.GearTexture:SetHeight(16)
		self.GearTexture:SetWidth(16)
	end
	self.History = {}
end

function RevEng:TradeSkillsClosed()
	self:UnhookAll();
	self:UnregisterEvent("TRADE_SKILL_CLOSE")
end

function RevEng:Clicked(button, index)
	if(not IsShiftKeyDown()) then
		local _, _, itemID = string.find(GetTradeSkillReagentItemLink(GetTradeSkillSelectionIndex(), index), "-*:(%d+):.*")
		if (itemID) then
			if (self.TradeSkills[itemID]) then
				local _, _, HistoryID = string.find(GetTradeSkillItemLink(GetTradeSkillSelectionIndex()), "-*:(%d+):.*")
				table.insert(self.History, HistoryID)
				RevEng:MoveTo(itemID)
			end
		end
	end
	self.hooks[button]["OnClick"]();
	self:Left(button);
end

function RevEng:MoveUp()
	local itemID = table.remove(self.History)
	if(itemID) then
		RevEng:MoveTo(itemID)
	end
end

function RevEng:MoveTo(itemID)
	SetTradeSkillSubClassFilter(0, 1, 1)
	SelectTradeSkill(self.TradeSkills[itemID][1])
	TradeSkillFrame_SetSelection(self.TradeSkills[itemID][1])
	TradeSkillListScrollFrame:SetVerticalScroll(0)
	local inc = 16 * (self.TradeSkills[itemID][1] - 1)
	local List = TradeSkillListScrollFrame
	local scrollmax = TradeSkillListScrollFrame:GetVerticalScrollRange()
	TradeSkillListScrollFrame:SetVerticalScroll(inc)
	while(not string.find(TradeSkillSkill1:GetText(), self.TradeSkills[itemID][2]) and -- insurance =P 
			inc < scrollmax ) do
		inc = inc + 16
		TradeSkillListScrollFrame:SetVerticalScroll(inc)
	end
end

function RevEng:Entered(button, index)
	if(getglobal("TradeSkillReagent"..index) ~= button) then
		self:Debug("Error on button "..index);
		return
	end
	self:Debug("entering button");
	self.hooks[button]["OnEnter"]();
	local _, _, itemID = string.find(GetTradeSkillReagentItemLink(GetTradeSkillSelectionIndex(), index), "-*:(%d+):.*")
	if (itemID) then
		if (self.TradeSkills[itemID]) then
			self:Debug("Found matching item.")
			self.GearTexture:SetParent(button)
			self.GearTexture:ClearAllPoints()
			self.GearTexture:SetPoint("TOPLEFT", button)
			self.GearTexture:Show()
		else
			self.GearTexture:Hide()
		end
	end
end

function RevEng:Left(button)
	self.GearTexture:Hide()
	self.hooks[button]["OnLeave"]()
end

